<?php

if (!defined('_PS_VERSION_'))
	exit;

class PaidOnResults extends Module
{

	public function __construct()
	{
		$this->name = 'paidonresults';
		$this->tab = 'analytics_stats';
		$this->version = '2.0';
		$this->author = 'Paid On Results Ltd';
		$this->bootstrap = true;

		parent::__construct();

		$this->displayName = $this->l('Paid On Results');
		$this->description = $this->l('Integration for your Affiliate Network, Paid On Results.');
	}

	public function install()
	{
        return parent::install()
          && $this->registerHook('orderConfirmation')
          && $this->registerHook('footer');
	}

	public function hookDisplayFooter($params)
	{
		$merchant_id = Configuration::get('AVT_MERCHANT_ID');
		if ($merchant_id == '')
			return;

        $this->context->smarty->assign(array(
			'merchant_id' => $merchant_id,
        ));

        return $this->display(__FILE__, 'views/templates/hook/footer.tpl');

}

	public function hookOrderConfirmation($params)
	{
		//p($params);
		$merchant_id = Configuration::get('AVT_MERCHANT_ID');
		if (!$params['objOrder']->id || $merchant_id == '')
			return;

		$id_order = $params['objOrder']->id;
		$products = $params['objOrder']->getProducts();

$vm_code = "";
$rules = $params['objOrder']->getCartRules();

foreach ($rules as $c_rule){
if ($c_rule['value'] > 0){
if ($c_rule['id_cart_rule']){
$sql = 'SELECT code FROM '._DB_PREFIX_.'cart_rule WHERE id_cart_rule = '.$c_rule['id_cart_rule'];
if ($row = Db::getInstance()->getRow($sql))
$vm_code = $row['code'];
}
}
}
		$total_discount = $params['objOrder']->total_discounts;
		$purcharse = array();
		foreach ($products as $product)
			$purcharse[] = $product['product_id'].','.$product['total_wt'];
		$this->smarty->assign(array(
			'merchant_id' => $merchant_id,
			'id_order' => $id_order,
			'purcharse'	=> implode('|', $purcharse),
			'total_discount' => $total_discount,
			'voucher_code' => $vm_code
		));
		return $this->display(__FILE__, 'order_confirmation.tpl');
	}

	public function getContent()
	{
		$output = '';
		if (Tools::isSubmit('submitAdvanceTracking'))
		{
				Configuration::updateValue('AVT_MERCHANT_ID', Tools::getValue('AVT_MERCHANT_ID'));
				$output .= $this->displayConfirmation($this->l('Settings updated'));
		}
		return $output.$this->renderForm();
	}

	public function renderForm()
	{
		$fields_form = array(
			'form' => array(
				'legend' => array(
					'title' => $this->l('Settings'),
					'icon' => 'icon-cogs'
				),
				'input' => array(
					array(
						'type' => 'text',
						'label' => $this->l('Merchant ID'),
						'name' => 'AVT_MERCHANT_ID',
						'desc' => $this->l('Your Merchant ID which was given to you by Paid On Results.')
					),
				),
				'submit' => array(
					'title' => $this->l('Save')
				)
			),
		);

		$helper = new HelperForm();
		$helper->show_toolbar = false;
		$helper->table =  $this->table;
		$lang = new Language((int)Configuration::get('PS_LANG_DEFAULT'));
		$helper->default_form_language = $lang->id;
		$helper->allow_employee_form_lang = Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') ? Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') : 0;
		$this->fields_form = array();

		$helper->identifier = $this->identifier;
		$helper->submit_action = 'submitAdvanceTracking';
		$helper->currentIndex = $this->context->link->getAdminLink('AdminModules', false).'&configure='.$this->name.'&tab_module='.$this->tab.'&module_name='.$this->name;
		$helper->token = Tools::getAdminTokenLite('AdminModules');
		$helper->tpl_vars = array(
			'fields_value' => $this->getConfigFieldsValues(),
			'languages' => $this->context->controller->getLanguages(),
			'id_language' => $this->context->language->id
		);

		return $helper->generateForm(array($fields_form));
	}

	public function getConfigFieldsValues()
	{
		return array(
			'AVT_MERCHANT_ID' => Tools::getValue('AVT_MERCHANT_ID', Configuration::get('AVT_MERCHANT_ID'))
		);
	}
}